import { auth, getUsers, createUser, getUnits, getHospitals} from "./database.js";
import { signInWithEmailAndPassword, signOut } from "firebase/auth";
///////////////////////////////////login functions/////////////////////////////////////////////////////////////////////
//Log ins the user
async function login(email: string, password: string): Promise<boolean> {
  let returnValue = false;
  await signInWithEmailAndPassword(auth, email, password)
    .then(async (userCredential) => {
      const user = await getUsers({ uid: userCredential.user.uid });
      //should only store uid stores entire user currently
      localStorage.setItem("user", JSON.stringify(user));
      returnValue = true;
    })
    .catch((error) => {
      console.log(error);
      alert("Felaktiga inloggnings-uppgifter");
      returnValue = false;
    });
  return returnValue;
}

//Redirects to the login in screen and log outs the user
async function logout() {
  signOut(auth);
  localStorage.removeItem("user");
}

export { login, logout};
