"use strict";

import {
  createSuggestion,
  getObject,
  getHospitals,
  getUnits,
  getUsers
} from "../Database/database.js";
import {
  loadIdeaBank
} from "../SidebarAndHeader/pageHandler.js"

async function loadFilter(){
  const selectHospitalHTML = $('#selectHospital'); // loads the select type from html
  const selectUnitHTML = $('#selectDepartment'); // loads the select type from html
  const allHospitals = await getHospitals({});
  const allUnits = await getUnits({}); //here you can put constraints
  console.log(allHospitals);
  console.log(allUnits);
  allHospitals.forEach(user => {
    const optionElement = $('<option>').addClass('ideaCardFont')
                                       .val(user.id)
                                       .text(user.name)
  selectHospitalHTML.append(optionElement);
  });
  allUnits.forEach(user => {
    const optionElement = $('<option>').addClass('ideaCardFont')
                                       .val(user.id)
                                       .text(user.name)
  selectUnitHTML.append(optionElement);
  });

}

async function populateOptions(
 object: string,
 selectElement: HTMLSelectElement
) {
 const options = await getObject(object);
 options.forEach((option) => {
   
   const optionElement = document.createElement("option");
   optionElement.value = option.id; // Set the value
   optionElement.text = option.name; // Set the text
   optionElement.classList.add("option"); // Add the 'option' class

   selectElement.appendChild(optionElement);
 });
}

// Define the submitHandler function
export async function submitHandler() {

 const selectDepartment = document.getElementById(
   "selectHospital"
 ) as HTMLSelectElement;
 const selectUnit = document.getElementById(
   "selectDepartment"
 ) as HTMLSelectElement;

 //populateOptions("hospital", selectDepartment);
 //populateOptions("unit", selectUnit);

 // JavaScript to get the inputted text when the form is submitted
 const inputBoxFormNameInput = document.getElementById(
   "inputBoxFormNameInput"
 ) as HTMLSelectElement;
 const inputBoxFormName = document.getElementById(
   "inputBoxFormName"
 ) as HTMLSelectElement;
 const inputBoxFormAreaInput = document.getElementById(
   "inputBoxFormAreaInput"
 ) as HTMLSelectElement;
 const inputBoxFormArea = document.getElementById(
   "inputBoxFormArea"
 ) as HTMLSelectElement;
 const inputBoxFormContentInput = document.getElementById(
   "inputBoxFormContentInput"
 ) as HTMLSelectElement;
 const inputBoxFormContent = document.getElementById(
   "inputBoxFormContent"
 ) as HTMLSelectElement;
 const inputBoxFormPurposeInput = document.getElementById(
   "inputBoxFormPurposeInput"
 ) as HTMLSelectElement;
 const inputBoxFormPurpose = document.getElementById(
   "inputBoxFormPurpose"
 ) as HTMLSelectElement;
 const inputBoxFormMeasureInput = document.getElementById(
   "inputBoxFormMeasureInput"
 ) as HTMLSelectElement;
 const inputBoxFormMeasure = document.getElementById(
   "inputBoxFormMeasure"
 ) as HTMLSelectElement;
 const inputBoxFormIdeasInput = document.getElementById(
   "inputBoxFormIdeasInput"
 ) as HTMLSelectElement;
 const inputBoxFormIdeas = document.getElementById(
   "inputBoxFormIdeas"
 ) as HTMLSelectElement;
 const submitButton = document.getElementById(
   "suggestionButton"
 ) as HTMLSelectElement;

 inputBoxFormName.addEventListener("submit", (e) => {
   e.preventDefault();
 });
 inputBoxFormArea.addEventListener("submit", (e) => {
   e.preventDefault();
 });
 inputBoxFormContent.addEventListener("submit", (e) => {
   e.preventDefault();
 });
 inputBoxFormPurpose.addEventListener("submit", (e) => {
   e.preventDefault();
 });
 inputBoxFormMeasure.addEventListener("submit", (e) => {
   e.preventDefault();
 });
 inputBoxFormIdeas.addEventListener("submit", (e) => {
   e.preventDefault();
 });
 // Get values from each form and do something with them
 var nameInput = inputBoxFormNameInput.value;
 var areaInput = inputBoxFormAreaInput.value;
 var contentInput = inputBoxFormContentInput.value;
 var purposeInput = inputBoxFormPurposeInput.value;
 var measureInput = inputBoxFormMeasureInput.value;
 var ideasInput = inputBoxFormIdeasInput.value;

 if(nameInput == "" || areaInput == "" || contentInput == "" || purposeInput == "" || selectUnit.value == ""  || selectDepartment.value == "") {
  alert("Alla obligatoriska fält är inte ifyllda!");
 }
 else {

 var tmp = localStorage.getItem('user')

 if (!tmp){
  console.log("there is not an user in localStorage")
  return;
}
  var uid = JSON.parse(tmp)[0].uid;
  var user = await getUsers({uid : uid});
  console.log(user);
  console.log(user[0].uid);
  console.log(user[0].id);
  console.log(user[0].creatorHsaId);

 try {
  if (user[0].id) {
    createSuggestion(
      null, 
      user[0].id, //The unique identifyer for the user, not the idea
      nameInput,
      areaInput,
      contentInput,
      purposeInput,
      measureInput,
      ideasInput,
      selectUnit.value,
      selectDepartment.value,
      true
    );
    
  }
   // Call the createSuggestion function with the obtained values  
   loadIdeaBank();
 } catch {
   alert("Error creating");
 }
 }
}

export function loadPage() {
 const container = document.querySelector('#container-fluid');
 if (!container) return; // Stop if the container isn't found

 const scriptElement = document.createElement('script');
 scriptElement.src = '../dist/makeSuggestion.bundle.js';
 container.appendChild(scriptElement);

 const linkElement1 = document.createElement('link');
 linkElement1.rel = 'stylesheet';
 linkElement1.href = 'Make_Suggestion_Code/makeSuggestion.css';
 document.head.appendChild(linkElement1);

 const linkElement2 = document.createElement('link');
 linkElement2.rel = 'stylesheet';
 linkElement2.href = 'Activity_card_code/activitity_card.css';
 document.head.appendChild(linkElement2);


 fetch('Make_Suggestion_Code/makeSuggestion.html')
   .then(response => response.text())
   .then(data => {
     const tempContainer = document.createElement('div');
     tempContainer.innerHTML = data;
     const suggestionPage = tempContainer.querySelector('#suggestionPage');
     if (suggestionPage) {
       container.insertBefore(suggestionPage, container.firstChild);
       
         const submitButton = document.getElementById('suggestionButton') as HTMLButtonElement | null;

         if (submitButton) {
           submitButton.addEventListener('click', submitHandler);
         } else {
           console.error("Error: 'suggestionButton' not found");
         }
         loadFilter();
     }
   })
   .catch(error => {
     console.error('Failed to load the external HTML file:', error);
   });
}


