import * as currentProjects from "../currentProjects/currentProjects.js";
import * as suggestions from "../Make_Suggestion_Code/makeSuggestion.js";
import * as ideaBank from "../ideaBank/ideaBank.js";
import * as knowledgeBank from "../KnowledgeBank/knowledgeBank.js";
import * as completedProjects from "../KnowledgeBank/completedProjects.js";
import * as Nolans from "../KnowledgeBank/Nolans.js";
import * as genImprovMethods from "../KnowledgeBank/genImprovMethods.js";
import * as ContactOrganization from "../KnowledgeBank/ContactOrganization.js";
import * as Nolans1 from "../KnowledgeBank/Nolans1.js";
import * as Nolans2 from "../KnowledgeBank/Nolans2.js";
import * as Nolans3 from "../KnowledgeBank/Nolans3.js";
import * as Nolans4 from "../KnowledgeBank/Nolans4.js";
import * as Nolans5 from "../KnowledgeBank/Nolans5.js";
import * as Nolans6 from "../KnowledgeBank/Nolans6.js";
import * as Nolans7 from "../KnowledgeBank/Nolans7.js";
import * as profile from "../homePage.js";
import * as profilePage from "../profilePage.js";
import * as projectPageP from "../projectPage/projectPageP.js";
import * as projectPageG from "../projectPage/projectPageG.js";
import * as projectPageS from "../projectPage/projectPageS.js";
import * as projectPageA from "../projectPage/projectPageA.js";

import * as login from "../login/login.js";
import * as authentication from "../Database/authentication.js";
import * as initiateIdea from "../initiateForbattringsarbete/initiateIdea.js";

let NolansEventListenersAdded = false;
let knowledgeBankListenersAdded = false;
let currentProjectsListenersAdded = false;
let completedProjectsListenersAdded = false;

//Function to make all button-hover-effects work
buttonHoverHandler();

//Listeners for all the different pages
$("#ideaBankView")
  .off("click")
  .on("click", function (e) {
    e.preventDefault();
    loadIdeaBank();
  });

$("#regionOstergotlandImage")
  .off("click")
  .on("click", function (e) {
    e.preventDefault();
    loadMyProfile();
  });

$("#log-out-button")
  .off("click")
  .on("click", function (e) {
    e.preventDefault();
    logOut();
  });

$("#settingsView")
  .off("click")
  .on("click", function (e) {
    e.preventDefault();
    loadSettings();
  });

$("#knowledgeBankView")
  .off("click")
  .on("click", function (e) {
    e.preventDefault();
    loadKnowledgeBank();
  });

$("#profileView")
  .off("click")
  .on("click", function (e) {
    e.preventDefault();
    loadMyProfilePage();
  });

$("#profileDropdown")
  .off("click")
  .on("click", function (e) {
    e.preventDefault();
    loadMyProfilePage();
  });

$("#supportView")
  .off("click")
  .on("click", function (e) {
    e.preventDefault();
    loadSupport();
  });

$("#currentProjects")
  .off("click")
  .on("click", function (e) {
    e.preventDefault();
    loadCurrentProjects();
  });

$("#suggestionView")
  .off("click")
  .on("click", function (e) {
    e.preventDefault();
    loadSuggestionPage();
  });

$("#button-login")
  .off("click")
  .on("click", async function (e) {
    e.preventDefault();
    if (await login.handleLogin()) {
      hideElement("login-container");
      loggedIn();
    }
  });

//if (x!true){ x = false}

function setTitle(text: string) {
  const title = document.getElementById("titleCurrentPage");
  if (title) {
    title.textContent = text;
  }
}
//Function to hide HTML elements
export function hideElement(elementId: string) {
  const element = document.getElementById(elementId);
  if (element) {
    element.style.display = "none";
  }
}

function removeDisplayStyle(elementId: string) {
  const element = document.getElementById(elementId);
  if (element) {
    element.style.display = "";
  }
}

function setFlexDisplay(elementId: string) {
  const element = document.getElementById(elementId);
  if (element) {
    element.style.display = "flex";
  }
}

//help function after logging in successfully
export function loggedIn() {
  setFlexDisplay("main");
  loadMyProfile();
}

//Function that logs out the user
function logOut() {
  hideElement("main");
  removeDisplayStyle("login-container");
  console.log("du klickade på logga ut knappen");
  authentication.logout();
}

function clearContent() {
  const container = $("#container-fluid");
  container.empty();
  const clonedContainer = container.clone();
  container.replaceWith(clonedContainer);
}

export function loadCurrentProjects() {
  clearContent();
  setTitle("Förbättringsarbeten");
  currentProjects.loadPage(currentProjectsListenersAdded);
  currentProjectsListenersAdded = true;
}

function loadSuggestionPage() {
  clearContent();
  setTitle("Ge förslag");
  suggestions.loadPage();
}

export function loadInitiatePage(id: string) {
  clearContent();
  setTitle("Gör ditt förslag till ett förbättringsarbete!");
  initiateIdea.loadPage(id);
}

export function loadIdeaBank() {
  clearContent();
  setTitle("Förbättringsförslag");
  ideaBank.loadPage();
}

function loadKnowledgeBank() {
  clearContent();
  setTitle("Metoder & Teorier");
  knowledgeBank.loadPage();
  //Loading Page-specific eventlistneres
  if (!knowledgeBankListenersAdded) {
    console.log("###################################laddas");
    document.addEventListener("click", function (event) {
      const target = event.target as HTMLElement;
      if (target.id === "buttons-kunskapsbanken-button1") {
        loadNolansMain();
      } else if (target.id === "buttons-kunskapsbanken-button2") {
        loadGenImprovMethods();
      } else if (target.id === "buttons-kunskapsbanken-button3") {
        loadCompletedProjects();
      } else if (target.id === "buttons-kunskapsbanken-button4") {
        loadContactOrganizations();
      } else if (target.id === "knowledge-backbutton") {
        loadKnowledgeBank();
      }
    });
    knowledgeBankListenersAdded = true;
  }
}

function loadGenImprovMethods() {
  clearContent();
  setTitle("Generella förbättringsmetoder");
  genImprovMethods.loadPage();
}

function loadContactOrganizations() {
  clearContent();
  setTitle("Kontaktinformation");
  ContactOrganization.loadPage();
}

function loadNolansMain() {
  clearContent();
  setTitle("Nolans förbättringsmodell");
  Nolans.loadPage();
  if (!NolansEventListenersAdded) {
    document.addEventListener("click", function (event) {
      const target = event.target as HTMLElement;
      if (target.id === "SattaMalSyfte") {
        clearContent();
        loadNolans1();
      } else if (target.id === "MataFoljaUpp") {
        clearContent();
        loadNolans2();
      } else if (target.id === "SamlaIdeer") {
        clearContent();
        loadNolans3();
      } else if (target.id === "nolansBackButton") {
        clearContent();
        loadKnowledgeBank();
      } else if (target.id === "nolans4") {
        clearContent();
        loadNolans4();
      } else if (target.id === "nolans5") {
        clearContent();
        loadNolans5();
      } else if (target.id === "nolans6") {
        clearContent();
        loadNolans6();
      } else if (target.id === "nolans7") {
        clearContent();
        loadNolans7();
      }
    });
    NolansEventListenersAdded = true;
  }
}

function loadNolans1() {
  clearContent();
  setTitle("Nolans förbättringsmodell");
  Nolans1.loadPage();
}

function loadNolans2() {
  clearContent();
  setTitle("Nolans förbättringsmodell");
  Nolans2.loadPage();
}

function loadNolans3() {
  clearContent();
  setTitle("Nolans förbättringsmodell");
  Nolans3.loadPage();
}

function loadNolans4() {
  clearContent();
  setTitle("Nolans förbättringsmodell");
  Nolans4.loadPage();
}
function loadNolans5() {
  clearContent();
  setTitle("Nolans förbättringsmodell");
  Nolans5.loadPage();
}
function loadNolans6() {
  clearContent();
  setTitle("Nolans förbättringsmodell");
  Nolans6.loadPage();
}
function loadNolans7() {
  clearContent();
  setTitle("Nolans förbättringsmodell");
  Nolans7.loadPage();
}

export function loadProjectPageP(projectId: string) {
  clearContent();
  setTitle("Planera");
  projectPageP.loadPage(projectId);
}
export function loadProjectPageG(projectId: string) {
  clearContent();
  setTitle("Göra");
  projectPageG.loadPage(projectId);
}

export function loadProjectPageS(projectId: string) {
  clearContent();
  setTitle("Studera");
  projectPageS.loadPage(projectId);
}

export function loadProjectPageA(projectId: string) {
  clearContent();
  setTitle("Agera");
  projectPageA.loadPage(projectId);
}

function loadCompletedProjects() {
  clearContent();
  setTitle("Avslutade förbättringsarbeten");
  completedProjects.loadPage(completedProjectsListenersAdded);
  if (!completedProjectsListenersAdded) {
    //Page-specific eventlisteners
    document.addEventListener("click", function (event) {
      const target = event.target as HTMLElement;
      if (target.id === "departmentDropdown") {
      } else if (target.id === "dateDropdown") {
      }
    });
  }
  completedProjectsListenersAdded = true;
}

function loadMyProfile() {
  clearContent();
  setTitle("Förbättringsportalen");
  profile.loadPage(currentProjectsListenersAdded); //fix containers
}

function loadMyProfilePage() {
  clearContent();
  setTitle("Din Profil");
  profilePage.loadPage(currentProjectsListenersAdded); //fix containers
}

function loadSettings() {
  clearContent();
  setTitle("Inställningar");
  //load settings function
}

function loadSupport() {
  clearContent();
  setTitle("Hjälp och Support");
  //load support function
}

//BUtton hover handling
async function buttonHoverHandler() {
  const allButtons = document.querySelectorAll(".nav-link");
  const buttons = Array.from(allButtons).filter(
    (button) =>
      button.id !== "regionOstergotlandImage" &&
      button.id !== "log-out-button" &&
      button.id !== "profileDropdown" &&
      button.id !== "suggestionButton"
  );

  const profDropButton = document.getElementById("profileDropdown");
  const logoButton = document.getElementById("regionOstergotlandImage");
  const logOutButton = document.getElementById("log-out-button");
  const submitButton = document.getElementById("suggestionButton");
  const ideaBankButton = document.getElementById("ideaBankView");

  buttons.forEach((button) => {
    button.addEventListener("click", () => {
      buttons.forEach((b) => b.classList.remove("active"));
      button.classList.add("active");
    });
  });
  if (logoButton) {
    logoButton.addEventListener("click", () => {
      buttons.forEach((b) => b.classList.remove("active"));
    });
  }
  if (logOutButton) {
    logOutButton.addEventListener("click", () => {
      buttons.forEach((b) => b.classList.remove("active"));
    });
  }
  if (profDropButton) {
    profDropButton.addEventListener("click", () => {
      buttons.forEach((b) => b.classList.remove("active"));
    });
  }
  if (submitButton && ideaBankButton) {
    submitButton.addEventListener("click", () => {
      buttons.forEach((b) => b.classList.remove("active"));
      ideaBankButton.classList.add("active");
    });
  }
}
