import { data } from "jquery";
import { login } from "../Database/authentication.js";
import { hideElement, loggedIn } from "../SidebarAndHeader/pageHandler.js";

//tries to login with the information filled in, in the login interace
export function handleLogin() {
  const username = document.getElementById("email-login") as HTMLInputElement;
  const password = document.getElementById("password-login") as HTMLInputElement;
  if (!(username && password)) {
    return false;
  } else {
    return login(username.value, password.value);
  }
}

export function loadPage() {
  const container = document.querySelector("#container-fluid");

  if (!container) return; // Stop if the container isn't found

  fetch("login/login.html")
    .then((response) => response.text())
    .then((data) => {
      // Create a temporary container element to hold the loaded content
      const tempContainer = document.createElement("div");
      tempContainer.innerHTML = data;

      // Select the specific element with the class you want
      const specificElement = tempContainer.querySelector(".login-container");

      if (specificElement) {
        // Insert the specific element into the target element
        container.insertBefore(specificElement, container.firstChild);
      }
      const username = document.getElementById(
        "email-login"
      ) as HTMLInputElement;
      const password = document.getElementById(
        "password-login"
      ) as HTMLInputElement;
      username.addEventListener("keydown", async function (event) {
        if (event.key === "Enter") {
          if (await handleLogin()) {
            hideElement("login-container");
            loggedIn();
          }
        }
      });
      password.addEventListener("keydown", async function (event) {
        if (event.key === "Enter") {
          if (await handleLogin()) {
            hideElement("login-container");
            loggedIn();
          }
        }
      });
    })
    .catch((error) => {
      console.error("Failed to load the external HTML file:", error);
    });
}
