#!/bin/sh

npm install
# Compile TypeScript files
tsc -p tsconfig.json

# Build the project
npm run build

# Build Docker image
docker build -t websiteapp .

# Run Docker container
docker run -p 5001:5001 websiteapp &

# Wait for the Docker container to start
sleep 5

# Open the browser
if [[ "$OSTYPE" == "linux-gnu"* ]]; then
    xdg-open http://localhost:5001
elif [[ "$OSTYPE" == "darwin"* ]]; then
    open http://localhost:5001
elif [[ "$OSTYPE" == "win32" || "$OSTYPE" == "msys" ]]; then
    start http://localhost:5001
else
    echo "Could not detect OS or OS not supported"
    exit 1
fi
